//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ȉ̊֐̃jbg
//
//  (1) zL[R[h̒萔̕܂ ASCII 牼zL[R[h̒l擾
//  (2) zL[R[h̒l牼zL[R[h̒萔̕擾
//  (3) zL[R[h̒萔̗ (Xg擾)
// 
//-----------------------------------------------------------------------------
//
//  yz
//
//  2021N0827 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows [Version 10.0.19042] Pro 64 bit + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plvkEnum;

interface

uses
  Winapi.Windows, System.SysUtils, System.Classes;

  function vkTextToVirtualKey(vkText: string): Cardinal;
  function VirtualKeyToVKText(KeyByte: Byte): string;
  function EnumVkText(vkList: TStringList): Integer;

  implementation

uses
  System.StrUtils,
  System.TypInfo;

type
  //-----------------------------------------------------------------
  //  zL[R[h̗񋓌^`
  //  Delphi XE5(UP2) Pro  System.UITypes.pas ̃Xg쐬
  //  vO쐬Ė`̒l̕ǉ
  //
  //  ȉ͍폜 (ldĂ̂)
  //    vkHangul = $15
  //    vkHanja,= $19
  //  ȉ̈ʒuύX
  //    kEscape = $1B
  //
  //  THoge = (aaa = 10, bbb = 15, ccc = 55);
  //  ̂悤ȗ񋓌^`ł
  //   TypeInfo gp̎擾͂łȂ
  //  (ICwvQ)
  //  THoge ͌^Ă܂ṽRpCG[ƂȂ
  //-----------------------------------------------------------------
  TplvkEnum = (
  { Virtual Keys, Standard Set }
  not_used_x00,       // = $00;
  vkLButton,          // = $01;  {   1 }
  vkRButton,          // = $02;  {   2 }
  vkCancel,           // = $03;  {   3 }
  vkMButton,          // = $04;  {   4 }
  vkXButton1,         // = $05;  {   5 }
  vkXButton2,         // = $06;  {   6 }
  not_used_x07,       // = $07;
  vkBack,             // = $08;  {   8 }
  vkTab,              // = $09;  {   9 }
  vkLineFeed,         // = $0A;  {  10 }
  not_used_x0B,       // = $0B;
  vkClear,            // = $0C;  {  12 }
  vkReturn,           // = $0D;  {  13 }
  not_used_x0E,       // = $0E;
  not_used_x0F,       // = $0F;
  vkShift,            // = $10;  {  16 }
  vkControl,          // = $11;  {  17 }
  vkMenu,             // = $12;  {  18 }
  vkPause,            // = $13;  {  19 }
  vkCapital,          // = $14;  {  20 }
  vkKana,             // = $15;  {  21 }
  not_used_x16,       // = $16;
  vkJunja,            // = $17;  {  23 }
  vkFinal,            // = $18;  {  24 }
  vkKanji,            // = $19;  {  25 }
  not_used_x1A,       // = $1A;
  vkEscape,           // = $1B;  {  27 }
  vkConvert,          // = $1C;  {  28 }
  vkNonConvert,       // = $1D;  {  29 }
  vkAccept,           // = $1E;  {  30 }
  vkModeChange,       // = $1F;  {  31 }
  vkSpace,            // = $20;  {  32 }
  vkPrior,            // = $21;  {  33 }
  vkNext,             // = $22;  {  34 }
  vkEnd,              // = $23;  {  35 }
  vkHome,             // = $24;  {  36 }
  vkLeft,             // = $25;  {  37 }
  vkUp,               // = $26;  {  38 }
  vkRight,            // = $27;  {  39 }
  vkDown,             // = $28;  {  40 }
  vkSelect,           // = $29;  {  41 }
  vkPrint,            // = $2A;  {  42 }
  vkExecute,          // = $2B;  {  43 }
  vkSnapshot,         // = $2C;  {  44 }
  vkInsert,           // = $2D;  {  45 }
  vkDelete,           // = $2E;  {  46 }
  vkHelp,             // = $2F;  {  47 }
  { vk0 thru vk9 are the same as ASCII '0' thru '9' ($30 - $39) }
  vk0,                // = $30;  {  48 }
  vk1,                // = $31;  {  49 }
  vk2,                // = $32;  {  50 }
  vk3,                // = $33;  {  51 }
  vk4,                // = $34;  {  52 }
  vk5,                // = $35;  {  53 }
  vk6,                // = $36;  {  54 }
  vk7,                // = $37;  {  55 }
  vk8,                // = $38;  {  56 }
  vk9,                // = $39;  {  57 }
  not_used_x3A,       // = $3A;
  not_used_x3B,       // = $3B;
  not_used_x3C,       // = $3C;
  not_used_x3D,       // = $3D;
  not_used_x3E,       // = $3E;
  not_used_x3F,       // = $3F;
  not_used_x40,       // = $40;
  { vkA thru vkZ are the same as ASCII 'A' thru 'Z' ($41 - $5A) }
  vkA,                // = $41;  {  65 }
  vkB,                // = $42;  {  66 }
  vkC,                // = $43;  {  67 }
  vkD,                // = $44;  {  68 }
  vkE,                // = $45;  {  69 }
  vkF,                // = $46;  {  70 }
  vkG,                // = $47;  {  71 }
  vkH,                // = $48;  {  72 }
  vkI,                // = $49;  {  73 }
  vkJ,                // = $4A;  {  74 }
  vkK,                // = $4B;  {  75 }
  vkL,                // = $4C;  {  76 }
  vkM,                // = $4D;  {  77 }
  vkN,                // = $4E;  {  78 }
  vkO,                // = $4F;  {  79 }
  vkP,                // = $50;  {  80 }
  vkQ,                // = $51;  {  81 }
  vkR,                // = $52;  {  82 }
  vkS,                // = $53;  {  83 }
  vkT,                // = $54;  {  84 }
  vkU,                // = $55;  {  85 }
  vkV,                // = $56;  {  86 }
  vkW,                // = $57;  {  87 }
  vkX,                // = $58;  {  88 }
  vkY,                // = $59;  {  89 }
  vkZ,                // = $5A;  {  90 }
  vkLWin,             // = $5B;  {  91 }
  vkRWin,             // = $5C;  {  92 }
  vkApps,             // = $5D;  {  93 }
  not_used_x5E,       // = $5E;
  vkSleep,            // = $5F;  {  95 }
  vkNumpad0,          // = $60;  {  96 }
  vkNumpad1,          // = $61;  {  97 }
  vkNumpad2,          // = $62;  {  98 }
  vkNumpad3,          // = $63;  {  99 }
  vkNumpad4,          // = $64;  { 100 }
  vkNumpad5,          // = $65;  { 101 }
  vkNumpad6,          // = $66;  { 102 }
  vkNumpad7,          // = $67;  { 103 }
  vkNumpad8,          // = $68;  { 104 }
  vkNumpad9,          // = $69;  { 105 }
  vkMultiply,         // = $6A;  { 106 }
  vkAdd,              // = $6B;  { 107 }
  vkSeparator,        // = $6C;  { 108 }
  vkSubtract,         // = $6D;  { 109 }
  vkDecimal,          // = $6E;  { 110 }
  vkDivide,           // = $6F;  { 111 }
  vkF1,               // = $70;  { 112 }
  vkF2,               // = $71;  { 113 }
  vkF3,               // = $72;  { 114 }
  vkF4,               // = $73;  { 115 }
  vkF5,               // = $74;  { 116 }
  vkF6,               // = $75;  { 117 }
  vkF7,               // = $76;  { 118 }
  vkF8,               // = $77;  { 119 }
  vkF9,               // = $78;  { 120 }
  vkF10,              // = $79;  { 121 }
  vkF11,              // = $7A;  { 122 }
  vkF12,              // = $7B;  { 123 }
  vkF13,              // = $7C;  { 124 }
  vkF14,              // = $7D;  { 125 }
  vkF15,              // = $7E;  { 126 }
  vkF16,              // = $7F;  { 127 }
  vkF17,              // = $80;  { 128 }
  vkF18,              // = $81;  { 129 }
  vkF19,              // = $82;  { 130 }
  vkF20,              // = $83;  { 131 }
  vkF21,              // = $84;  { 132 }
  vkF22,              // = $85;  { 133 }
  vkF23,              // = $86;  { 134 }
  vkF24,              // = $87;  { 135 }

  vkCamera,           // = $88;  { 136 }
  vkHardwareBack,     // = $89;  { 137 }
  not_used_x8A,       // = $8A;
  not_used_x8B,       // = $8B;
  not_used_x8C,       // = $8C;
  not_used_x8D,       // = $8D;
  not_used_x8E,       // = $8E;
  not_used_x8F,       // = $8F;

  vkNumLock,          // = $90;  { 144 }
  vkScroll,           // = $91;  { 145 }
  not_used_x92,       // = $92;
  not_used_x93,       // = $93;
  not_used_x94,       // = $94;
  not_used_x95,       // = $95;
  not_used_x96,       // = $96;
  not_used_x97,       // = $97;
  not_used_x98,       // = $98;
  not_used_x99,       // = $99;
  not_used_x9A,       // = $9A;
  not_used_x9B,       // = $9B;
  not_used_x9C,       // = $9C;
  not_used_x9D,       // = $9D;
  not_used_x9E,       // = $9E;
  not_used_x9F,       // = $9F;
  vkLShift,           // = $A0;  { 160 }
  vkRShift,           // = $A1;  { 161 }
  vkLControl,         // = $A2;  { 162 }
  vkRControl,         // = $A3;  { 163 }
  vkLMenu,            // = $A4;  { 164 }
  vkRMenu,            // = $A5;  { 165 }

  vkBrowserBack,      // = $A6;  { 166 }
  vkBrowserForward,   // = $A7;  { 167 }
  vkBrowserRefresh,   // = $A8;  { 168 }
  vkBrowserStop,      // = $A9;  { 169 }
  vkBrowserSearch,    // = $AA;  { 170 }
  vkBrowserFavorites, // = $AB;  { 171 }
  vkBrowserHome,      // = $AC;  { 172 }
  vkVolumeMute,       // = $AD;  { 173 }
  vkVolumeDown,       // = $AE;  { 174 }
  vkVolumeUp,         // = $AF;  { 175 }
  vkMediaNextTrack,   // = $B0;  { 176 }
  vkMediaPrevTrack,   // = $B1;  { 177 }
  vkMediaStop,        // = $B2;  { 178 }
  vkMediaPlayPause,   // = $B3;  { 179 }
  vkLaunchMail,       // = $B4;  { 180 }
  vkLaunchMediaSelect,// = $B5;  { 181 }
  vkLaunchApp1,       // = $B6;  { 182 }
  vkLaunchApp2,       // = $B7;  { 183 }
  not_used_xB8,       // = $B8;
  not_used_xB9,       // = $B9;

  vkSemicolon,        // = $BA;  { 186 }
  vkEqual,            // = $BB;  { 187 }
  vkComma,            // = $BC;  { 188 }
  vkMinus,            // = $BD;  { 189 }
  vkPeriod,           // = $BE;  { 190 }
  vkSlash,            // = $BF;  { 191 }
  vkTilde,            // = $C0;  { 192 }
  not_used_xC1,       // = $C1;
  not_used_xC2,       // = $C2;
  not_used_xC3,       // = $C3;
  not_used_xC4,       // = $C4;
  not_used_xC5,       // = $C5;
  not_used_xC6,       // = $C6;
  not_used_xC7,       // = $C7;
  not_used_xC8,       // = $C8;
  not_used_xC9,       // = $C9;
  not_used_xCA,       // = $CA;
  not_used_xCB,       // = $CB;
  not_used_xCC,       // = $CC;
  not_used_xCD,       // = $CD;
  not_used_xCE,       // = $CE;
  not_used_xCF,       // = $CF;
  not_used_xD0,       // = $D0;
  not_used_xD1,       // = $D1;
  not_used_xD2,       // = $D2;
  not_used_xD3,       // = $D3;
  not_used_xD4,       // = $D4;
  not_used_xD5,       // = $D5;
  not_used_xD6,       // = $D6;
  not_used_xD7,       // = $D7;
  not_used_xD8,       // = $D8;
  not_used_xD9,       // = $D9;
  not_used_xDA,       // = $DA;
  vkLeftBracket,      // = $DB;  { 219 }
  vkBackslash,        // = $DC;  { 220 }
  vkRightBracket,     // = $DD;  { 221 }
  vkQuote,            // = $DE;  { 222 }
  vkPara,             // = $DF;  { 223 }
  not_used_xE0,       // = $E0;
  not_used_xE1,       // = $E1;

  vkOem102,           // = $E2;  { 226 }
  vkIcoHelp,          // = $E3;  { 227 }
  vkIco00,            // = $E4;  { 228 }
  vkProcessKey,       // = $E5;  { 229 }
  vkIcoClear,         // = $E6;  { 230 }
  vkPacket,           // = $E7;  { 231 }
  not_used_xE8,       // = $E8;
  not_used_xE9,       // = $E9;
  not_used_xEA,       // = $EA;
  not_used_xEB,       // = $EB;
  not_used_xEC,       // = $EC;
  not_used_xED,       // = $ED;
  not_used_xEE,       // = $EE;
  not_used_xEF,       // = $EF;
  not_used_xF0,       // = $F0;
  not_used_xF1,       // = $F1;
  not_used_xF2,       // = $F2;
  not_used_xF3,       // = $F3;
  not_used_xF4,       // = $F4;
  not_used_xF5,       // = $F5;
  vkAttn,             // = $F6;  { 246 }
  vkCrsel,            // = $F7;  { 247 }
  vkExsel,            // = $F8;  { 248 }
  vkErEof,            // = $F9;  { 249 }
  vkPlay,             // = $FA;  { 250 }
  vkZoom,             // = $FB;  { 251 }
  vkNoname,           // = $FC;  { 252 }
  vkPA1,              // = $FD;  { 253 }
  vkOemClear,         // = $FE;  { 254 }
  vkNone              // = $FF;  { 255 }
  );

//-----------------------------------------------------------------------------
//  zL[R[h̒萔̕񂩂牼zL[R[h̒l擾֐
//  l擾łȂꍇ $FF Ԃ
//  ߂l 2 oCg̕ȂCʃoCĝݗL
//
//  ̕ VK_Shift, vkShift Ƃ
//  啶Ə̋ʂ͂Ȃ
//  1 ̎ ASCII ̃L[Ɖ߂
//-----------------------------------------------------------------------------
function vkTextToVirtualKey(vkText: string): Cardinal;
begin
  if Length(vkText) = 1 then begin
    Result := Lo(VkKeyScanEx(vkText[1], GetKeyboardLayout(0)));
  end else
  if (vkText[1] = '$') then begin
    Result := StrToIntDef(vkText, $FF);
  end else begin
    vkText := ReplaceText(vkText, '_', '');
    vkText := ReplaceText(vkText, 'vkHangul', 'vkKana');
    vkText := ReplaceText(vkText, 'vkHanja', 'vkKanji');
    Result := GetEnumValue(TypeInfo(TplvkEnum), vkText);
    if Result <= 0 then Result := $FF;
  end;
end;

//-----------------------------------------------------------------------------
//  zL[R[h̒l牼zL[R[h̒萔̕擾֐
//  ̒萔̒` System.UITypes.pas ɂ
//  萔̒`Ȃꍇ͋󕶎Ԃ
//-----------------------------------------------------------------------------
function VirtualKeyToVKText(KeyByte: Byte): string;
begin
  Result := GetEnumName(TypeInfo(TplvkEnum), KeyByte);

  if KeyByte = $15 then Result := 'vkKana';
  if KeyByte = $19 then Result := 'vkKanji';
  if ContainsText(Result, 'not_used') then Result := '';
end;

//-----------------------------------------------------------------------------
//  gL[R[h̒萔
//-----------------------------------------------------------------------------
function EnumVkText(vkList: TStringList): Integer;
var
  LpInfo : PTypeInfo;
  LpData : PTypeData;
  LText  : string;
  LIndex : Integer;
begin
  LpInfo := TypeInfo(TplvkEnum);
  LpData := GetTypeData(LpInfo);

  for LIndex := LpData^.MinValue to LpData^.MaxValue do begin
    LText :=  GetEnumName(LpInfo, LIndex);
    if ContainsText(LText, 'not_used') then Continue;
    vkList.add(LText);
  end;
  Result := vkList.Count;
end;

end.
